<?php
/**
 * Plugin Name: 1pxeye Meta Keywords and Description
 * Plugin URI:  https://plugins.1pxeye.com/1pxeye-mkd/
 * Description: Optimize web-hosted content that makes it better for SEO.
 * Version:     2023.12
 * Author:      1pxeye
 * Author URI:  https://plugins.1pxeye.com/
 * License:     GPL v2 or later
 * License URI: https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain: 1pxeye-meta-keywords-description
 */
defined('ABSPATH') or die('Access Denied!');

if (!class_exists('OnepxeyeMKD')) {
    class OnepxeyeMKD
    {
        public $plugin;
        public function __construct()
        {
            $this->plugin = plugin_basename(__FILE__);
            add_action('init', array($this, 'custom_post_type'));
            add_filter('plugin_action_links_' . $this->plugin, array($this, 'settings_link'));
            require_once plugin_dir_path(__FILE__) . '/functions/functions.php';
            require_once plugin_dir_path(__FILE__) . '/functions/front.php';

        }

        public function settings_link($links)
        {
            $settings_link = '<a href="admin.php?page=mkd-description-settings">Settings</a>';
            array_push($links, $settings_link);
            return $links;
        }

        public function custom_post_type()
        {

        }

        public function admin_enqueue()
        {
            wp_enqueue_media();
            wp_enqueue_style('onepxeye-mkd-admin-style', plugins_url('/assets/css/onepxeye-mkd-admin-style.css', __FILE__));
        }

        public function register_scripts()
        {
            add_action('admin_enqueue_scripts', array($this, 'admin_enqueue'));
        }

    }

    if (class_exists('OnepxeyeMKD')) {
        $OnepxeyeMKD = new OnepxeyeMKD();
        $OnepxeyeMKD->register_scripts();
    }

// activation
    require_once plugin_dir_path(__FILE__) . 'inc/Activative.php';
    register_activation_hook(__FILE__, array('MKDActivative', 'activate'));

// deactivation
    require_once plugin_dir_path(__FILE__) . 'inc/Deactivate.php';
    register_deactivation_hook(__FILE__, array('MKDDeactivate', 'deactive'));
}
