<?php

if (!class_exists('OnepxeyeOGC_settings')) {
    class OnepxeyeOGC_settings
    {
        public function __construct()
        {
            add_action('add_meta_boxes', array(
                $this,
                'add_meta_box',
            ));
            add_action('save_post', array(
                $this,
                'save',
            ));
            add_action('admin_menu', array($this, 'onepeye_ogc'));
            add_action('admin_init', array($this, 'OnepxeyeOGC_term_fields'));
        }

        public function OnepxeyeOGC_term_fields()
        {

            $ogc_post_types = get_option('ogc_posttypes');
            $ogc_taxes = get_object_taxonomies($ogc_post_types);
            foreach ($ogc_taxes as $ogc_tax) {

                add_action($ogc_tax . '_add_form_fields', function ($tag) {
                    $ogc_term_des = get_term_meta(@$tag->term_id, '_fb_term_ogc_description', true);
                    $ogc_term_title = get_term_meta(@$tag->term_id, '_fb_term_ogc_title', true);
                    $ogc_term_img_id = get_term_meta(@$tag->term_id, '_fb_term_ogc_image', true);
                    if (!empty($ogc_term_img_id)) {
                        $ogc_term_img = wp_get_attachment_image_src($ogc_term_img_id, 'medium')[0];
                    } else {
                        $ogc_term_img = '';
                    }

                    ?>
<div class="form-field term-ogc-title-wrap">
    <label for='cat_page_title'><?php _e('Open Graph Title');?></label>
    <input type="text" name="ogc_term_title" id="ogc_term_title" value="<?php echo $ogc_term_title; ?>" />
</div>
<div class="form-field term-ogc-des-wrap"><label for='cat_page_title'><?php _e('Open Graph Description');?></label>
    <textarea name='ogc_term_des' id='ogc_term_des'><?php echo $ogc_term_des; ?></textarea>
</div>
<div class="form-field term-ogc-image-wrap ogi-wrapper">
    <label for='cat_page_title'><?php _e('Open Graph Image');?></label>
    <div class="image-section">
        <?php
if (!empty($ogc_term_img)) {
                        ?>
        <img src="<?php echo esc_url($ogc_term_img); ?>" alt="" class="file_thumbnail">
        <?php
}
                    ?>
    </div>
    <input name='ogc_term_img' id='ogc_term_img' value="<?php echo esc_attr($ogc_term_img_id); ?>" class="hidden_object"
        type="hidden" />
    <div class="button-group"><input type='button' class="button-primary button-upload" value="Image Select"
            id="uploadimage" /><input type='button' class="button-primary button-delete" value="Delete Image"
            id="removeimage" />
    </div>
</div>
<?php
});

                add_action($ogc_tax . '_edit_form_fields', function ($tag) {
                    $ogc_term_des = get_term_meta($tag->term_id, '_fb_term_ogc_description', true);
                    $ogc_term_title = get_term_meta($tag->term_id, '_fb_term_ogc_title', true);
                    $ogc_term_img_id = get_term_meta($tag->term_id, '_fb_term_ogc_image', true);
                    $ogc_term_img = wp_get_attachment_image_src($ogc_term_img_id, 'medium')[0];
                    ?>
<tr class='form-field'>
    <th scope='row'><label for='cat_page_title'><?php _e('Open Graph Title');?></label></th>
    <td>
        <input type="text" name="ogc_term_title" id="ogc_term_title" value="<?php echo $ogc_term_title; ?>" />
    </td>
</tr>
<tr class='form-field'>
    <th scope='row'><label for='cat_page_title'><?php _e('Open Graph Description');?></label></th>
    <td>
        <textarea name='ogc_term_des' id='ogc_term_des'><?php echo $ogc_term_des; ?></textarea>
    </td>
</tr>
<tr class='form-field ogi-wrapper'>
    <th scope='row'><label for='cat_page_title'><?php _e('Open Graph Image');?></label></th>
    <td>
        <div class="ogi-item">
            <div class="image-section<?php if (!empty($ogc_term_img)) {' hasimg';}?>">
                <?php
if (!empty($ogc_term_img)) {
                        ?>
                <img src="<?php echo esc_url($ogc_term_img); ?>" alt="" class="file_thumbnail">
                <?php
}
                    ?>
            </div>
            <input name='ogc_term_img' id='ogc_term_img' value="<?php echo esc_attr($ogc_term_img_id); ?>"
                class="hidden_object" type="hidden" />
            <div class="button-group"><input type='button' class="button-primary button-upload" value="Image Select"
                    id="uploadimage" /><input type='button' class="button-primary button-delete" value="Delete Image"
                    id="removeimage" />
            </div>
        </div>







    </td>
</tr>
<?php
});
                add_action('edited_' . $ogc_tax, function ($term_id) {
                    if (isset($_POST['ogc_term_des'])) {
                        update_term_meta($term_id, '_fb_term_ogc_description', $_POST['ogc_term_des']);
                    }
                    if (isset($_POST['ogc_term_title'])) {
                        update_term_meta($term_id, '_fb_term_ogc_title', $_POST['ogc_term_title']);
                    }
                    if (isset($_POST['ogc_term_img'])) {
                        update_term_meta($term_id, '_fb_term_ogc_image', $_POST['ogc_term_img']);
                    }
                });
                add_action('create_' . $ogc_tax, function ($term_id) {
                    if (isset($_POST['ogc_term_des'])) {
                        update_term_meta($term_id, '_fb_term_ogc_description', $_POST['ogc_term_des']);
                    }
                    if (isset($_POST['ogc_term_title'])) {
                        update_term_meta($term_id, '_fb_term_ogc_title', $_POST['ogc_term_title']);
                    }
                    if (isset($_POST['ogc_term_img'])) {
                        update_term_meta($term_id, '_fb_term_ogc_image', $_POST['ogc_term_img']);
                    }
                });

            }
        }

        public function onepeye_ogc()
        {

            add_menu_page(
                'OG Controller',
                'OG Controller',
                'manage_options',
                'ogc-description-settings',
                array($this, 'set_meta_description'),
                'dashicons-share-alt2',
                3
            );
            add_action('admin_init', array($this, 'save_ogc_description_settings'));
        }

        public function set_meta_description()
        {
            require plugin_dir_path(__FILE__) . '../meta/description-admin.php';

        }

        public function save_ogc_description_settings()
        {
            register_setting('ogc-description-settings-group', 'ogc_posttypes');
            register_setting('ogc-description-settings-group', 'ogc_home_title_text');
            register_setting('ogc-description-settings-group', 'ogc_description_position');
            register_setting('ogc-description-settings-group', 'ogc_description_text');
            register_setting('ogc-description-settings-group', 'ogc_home_description');
            register_setting('ogc-description-settings-group', 'ogc_post_description');
            register_setting('ogc-description-settings-group', 'ogc_global_description');
            register_setting('ogc-description-settings-group', 'ogc_home_og_img');
            register_setting('ogc-description-settings-group', 'ogc_post_og_img');
            register_setting('ogc-description-settings-group', 'ogc_global_og_img');
            register_setting('ogc-description-settings-group', 'ogc_twitter_card_username');
            register_setting('ogc-description-settings-group', 'ogc_twitter_card_type');
            register_setting('ogc-description-settings-group', 'remove_ogc_data_on_uninstall');

            add_settings_section('og-active-post-type', 'Activated Post type', array($this, 'og_posttype_options'), 'ogc-posttype-settings');
            add_settings_field('active-post-type', '<strong>Post Types</strong>', array($this, 'og_posttype_settings'), 'ogc-posttype-settings', 'og-active-post-type');

            add_settings_section('og-custom-setting', 'Custom og:title', array($this, 'og_custom_options'), 'ogc-custom-settings');
            add_settings_field('home-title-text', '<strong>Home Title</strong>Home / Front Page', array($this, 'og_home_title_text'), 'ogc-custom-settings', 'og-custom-setting');
            add_settings_field('og-description-text', '<strong>Additional text</strong>Subpage', array($this, 'og_description_text'), 'ogc-custom-settings', 'og-custom-setting');
            add_settings_field('og-description-position', '<strong>Additional text<br>Position</strong>Subpage', array($this, 'og_description_position'), 'ogc-custom-settings', 'og-custom-setting');

            add_settings_section('og-description-text', 'Default description text settings', array($this, 'og_description_options'), 'ogc-description-settings');
            add_settings_field('home-des-text', '<strong>Homepage</strong>Home / Front Page', array($this, 'og_home_des_text'), 'ogc-description-settings', 'og-description-text');
            add_settings_field('post-des-text', '<strong>Singular</strong>Post / Page etc.', array($this, 'og_post_des_text'), 'ogc-description-settings', 'og-description-text');
            add_settings_field('global-des-text', '<strong>Global</strong>Situations that not mentioned above', array($this, 'og_global_des_text'), 'ogc-description-settings', 'og-description-text');

            add_settings_section('og-image', 'Default og image settings', array($this, 'og_images_options'), 'ogimages-settings');
            add_settings_field('home-og-image', '<strong>Homepage</strong>Home / Front Page', array($this, 'og_home_image'), 'ogimages-settings', 'og-image');
            add_settings_field('post-og-image', '<strong>Singular</strong>Post / Page etc.', array($this, 'og_post_image'), 'ogimages-settings', 'og-image');
            add_settings_field('global-og-image', '<strong>Global</strong>Situations that not mentioned above', array($this, 'og_global_image'), 'ogimages-settings', 'og-image');

            add_settings_section('og-twitter-card', 'Twitter Card settings', array($this, 'og_twitter_card_options'), 'ogc-twitter_card-settings');
            add_settings_field('twitter_card_type', '<strong>Card Type</strong>', array($this, 'og_twitter_card_type_settings'), 'ogc-twitter_card-settings', 'og-twitter-card');
            add_settings_field('twitter_card_username', '<strong>Username</strong>', array($this, 'og_twitter_card_username_settings'), 'ogc-twitter_card-settings', 'og-twitter-card');

            add_settings_section('og-remove-uninstall', 'Misc', array($this, 'og_remove_uninstall_options'), 'ogc-remove_uninstall-settings');
            add_settings_field('remove-data-og', '<strong>Remove Data</strong>', array($this, 'og_remove_uninstall_settings'), 'ogc-remove_uninstall-settings', 'og-remove-uninstall');
        }

        public function add_meta_box($post_type)
        {
            $ogc_post_types = get_option('ogc_posttypes');
            if (empty($ogc_post_types)) {
                $ogc_post_types = array();
            }
            $post_types = $ogc_post_types;
            if (in_array($post_type, $post_types)) {
                add_meta_box('og_post_settings', 'Open Graph settings', array(
                    $this,
                    'render_og_settings',
                ), $post_type, 'normal', 'default');
            }
        }

        public function render_og_settings($post)
        {
            $og_title_field = get_post_meta($post->ID, '_ogc_title_field', true);
            $og_des_field = get_post_meta($post->ID, '_ogc_des_field', true);
            ?>
<div class="og-title">
    <h4>og:title</h4>
    <input type="text" name="og_title_field" value="<?php echo $og_title_field; ?>" />
</div>
<div class="og-des-textarea">
    <h4>og:description</h4>
    <textarea name="og_des_field"><?php echo $og_des_field; ?></textarea>
</div>
<?php
}

        public function save($post_id)
        {
            if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
                return $post_id;
            }
            if (isset($_POST['post_type']) && 'page' == $_POST['post_type']) {
                if (!current_user_can('edit_page', $post_id)) {
                    return $post_id;
                }
            } else {
                if (!current_user_can('edit_post', $post_id)) {
                    return $post_id;
                }
            }
            update_post_meta($post_id, '_ogc_des_field', !empty($_POST['og_des_field']) ? $_POST['og_des_field'] : "");
            update_post_meta($post_id, '_ogc_title_field', !empty($_POST['og_title_field']) ? $_POST['og_title_field'] : "");
        }

        public function og_posttype_settings()
        {
            $ogc_posttypes = get_option('ogc_posttypes');
            if (empty($ogc_posttypes)) {
                $ogc_posttypes = array();
            }
            $args = array(
                'public' => true,
                // '_builtin' => false,
            );
            $output = 'names';
            $operator = 'or';
            $post_types = array();
            foreach (get_post_types($args, $output, $operator) as $post_type) {
                $post_types[] = $post_type;
            }
            $post_types_array = \array_diff($post_types, ["attachment", "revision", "es_template", "rl_gallery"]);
            $post_types_array = array_values($post_types_array);

            echo '<div class="labels">';

            foreach ($post_types_array as $pt) {
                ?>
<label for="<?php echo $pt; ?>"><input type="checkbox" name="ogc_posttypes[]" value="<?php echo $pt; ?>"
        id="<?php echo $pt; ?>" <?php if (in_array($pt, $ogc_posttypes)) {echo 'checked';}?>><?php echo $pt; ?></label>
<?php
}
            echo '</div>';

            ?>
<?php
}

        public function og_home_title_text()
        {
            $ogc_home_title_text = get_option('ogc_home_title_text');
            ?>
<input type="text" value="<?php echo esc_attr($ogc_home_title_text); ?>" name="ogc_home_title_text">
<div class="ogc-des-text">These texts are used to replace the default value. Default value is website name.</div>
<?php
}

        public function og_description_text()
        {
            $ogc_description_text = get_option('ogc_description_text');
            ?>
<input type="text" value="<?php echo esc_attr($ogc_description_text); ?>" name="ogc_description_text">
<div class="ogc-des-text">These texts are used to display on the left or right side of subpage title.</div>
<?php
}

        public function og_description_position()
        {
            $ogc_description_position = get_option('ogc_description_position');
            if (empty($ogc_description_position)) {
                $ogc_description_position = "Right side";
            }
            ?>
<div class="radio-group">
    <div>
        <label><input type="radio" value="Left side" <?php checked('Left side', $ogc_description_position);?>
                name="ogc_description_position">Left side</label>
    </div>
    <div><label><input type="radio" value="Right side" <?php checked('Right side', $ogc_description_position);?>
                name="ogc_description_position">Right side</label></div>
</div>
<div class="ogc-des-text">This option will set the position of the additional text set above which is relative to
    subpage
    title. It's only work when additional text not empty.</div>
<?php
}

        public function og_home_des_text()
        {
            $ogc_home_description = get_option('ogc_home_description');
            ?>
<textarea name="ogc_home_description"><?php echo esc_attr($ogc_home_description); ?></textarea>
<?php
}

        public function og_post_des_text()
        {
            $ogc_post_description = get_option('ogc_post_description');
            ?>
<textarea name="ogc_post_description"><?php echo esc_attr($ogc_post_description); ?></textarea>
<?php
}

        public function og_global_des_text()
        {
            $ogc_global_description = get_option('ogc_global_description');
            ?>
<textarea name="ogc_global_description"><?php echo esc_attr($ogc_global_description); ?></textarea>
<?php
}

        public function og_home_image()
        {
            $ogc_home_og_img = get_option('ogc_home_og_img');
            ?>

<div class="media-control">
    <?php
if (!empty($ogc_home_og_img)) {
                ?><figure>
        <img src="<?php echo esc_url($ogc_home_og_img); ?>" alt="">
    </figure>
    <?php }?>
    <div class="media-btns">
        <input type="hidden" name="ogc_home_og_img" value="<?php echo esc_url($ogc_home_og_img); ?>"
            class="hidden_object" />
        <div class="button-group"><input type='button' class="button-primary button-upload" value="Image select"
                id="uploadimage" /><input type='button' class="button-primary button-delete" value="Remove Image"
                id="removeimage" />
        </div>
    </div>

</div>
<?php
}

        public function og_post_image()
        {
            $ogc_post_og_img = get_option('ogc_post_og_img');
            ?>

<div class="media-control">
    <?php
if (!empty($ogc_post_og_img)) {
                ?><figure>
        <img src="<?php echo esc_url($ogc_post_og_img); ?>" alt="">
    </figure>
    <?php }?>
    <div class="media-btns">
        <input type="hidden" name="ogc_post_og_img" value="<?php echo esc_url($ogc_post_og_img); ?>"
            class="hidden_object" />
        <div class="button-group"><input type='button' class="button-primary button-upload" value="Image select"
                id="uploadimage" /><input type='button' class="button-primary button-delete" value="Remove Image"
                id="removeimage" />
        </div>
    </div>
</div>
<?php
}

        public function og_global_image()
        {
            $ogc_global_og_img = get_option('ogc_global_og_img');
            ?>

<div class="media-control">
    <?php
if (!empty($ogc_global_og_img)) {
                ?><figure>
        <img src="<?php echo esc_url($ogc_global_og_img); ?>" alt="">
    </figure>
    <?php }?>
    <div class="media-btns">
        <input type="hidden" name="ogc_global_og_img" value="<?php echo esc_url($ogc_global_og_img); ?>"
            class="hidden_object" />
        <div class="button-group"><input type='button' class="button-primary button-upload" value="Image select"
                id="uploadimage" /><input type='button' class="button-primary button-delete" value="Remove Image"
                id="removeimage" />
        </div>
    </div>

</div>
<?php
}
        public function og_custom_options()
        {

        }

        public function og_posttype_options()
        {

        }

        public function og_description_options()
        {

        }

        public function og_images_options()
        {
        }
        public function og_twitter_card_options()
        {
        }
        public function og_remove_uninstall_options()
        {
        }

        public function og_twitter_card_type_settings()
        {
            $ogc_twitter_card_type = get_option('ogc_twitter_card_type');
            ?>
<select name="ogc_twitter_card_type" class="max200">
    <option value="">- select a type -</option>
    <option value="summary_large_image" <?php selected($ogc_twitter_card_type, 'summary_large_image');?>>
        summary_large_image</option>
    <option value="summary" <?php selected($ogc_twitter_card_type, 'summary');?>>summary</option>
    <option value="app" <?php selected($ogc_twitter_card_type, 'app');?>>app</option>
    <option value="player" <?php selected($ogc_twitter_card_type, 'player');?>>player</option>
</select>
<div class="ogc-des-text">The card type, which will be one of “summary”, “summary_large_image”, “app”, or “player”.
</div>
<?php
}

        public function og_twitter_card_username_settings()
        {
            $ogc_twitter_card_username = get_option('ogc_twitter_card_username');
            ?>
<input type="text" name="ogc_twitter_card_username" value="<?php echo $ogc_twitter_card_username; ?>" class="max200">
<div class="ogc-des-text">@username for the website used in the card footer.</div>
<?php
}

        public function og_remove_uninstall_settings()
        {
            $remove_ogc_data_on_uninstall = get_option('remove_ogc_data_on_uninstall');
            echo '<div class="labels">';
            ?>
<label><input type="checkbox" name="remove_ogc_data_on_uninstall" value="remove_data"
        <?php checked($remove_ogc_data_on_uninstall, 'remove_data');?>>Remove</label>
<?php echo '</div>';
            ?>
<div class="ogc-des-text">Check this box if you would like to completely remove all of its data when the plugin is
    deleted.</div>
<?php

        }

    }

    if (class_exists('OnepxeyeOGC_settings')) {
        $OnepxeyeOGC_settings = new OnepxeyeOGC_settings();
    }

}